﻿using System;
using System.Windows.Controls;
using System.Windows;

namespace Telerik.Windows.QuickStart
{
    internal static class VisualStates
    {
        // Fields
        public const string GroupActive = "ActiveStates";
        public const string GroupCalendarButtonFocus = "CalendarButtonFocusStates";
        public const string GroupCommon = "CommonStates";
        public const string GroupFocus = "FocusStates";
        public const string GroupSelection = "SelectionStates";
        public const string GroupWatermark = "WatermarkStates";
        public const string StateActive = "Active";
        public const string StateCalendarButtonFocused = "CalendarButtonFocused";
        public const string StateCalendarButtonUnfocused = "CalendarButtonUnfocused";
        public const string StateDisabled = "Disabled";
        public const string StateFocused = "Focused";
        public const string StateInactive = "Inactive";
        public const string StateMouseOver = "MouseOver";
        public const string StateNormal = "Normal";
        public const string StatePressed = "Pressed";
        public const string StateSelected = "Selected";
        public const string StateUnfocused = "Unfocused";
        public const string StateUnselected = "Unselected";
        public const string StateUnwatermarked = "Unwatermarked";
        public const string StateWatermarked = "Watermarked";

        // Methods
        public static void GoToState(Control control, bool useTransitions, params string[] stateNames)
        {
            if (control == null)
            {
                throw new ArgumentNullException("control");
            }

            if (stateNames != null)
            {
                foreach (string str in stateNames)
                {
                    if (VisualStateManager.GoToState(control, str, useTransitions))
                    {
                        return;
                    }
                }
            }
        }
    }
}

 

