﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;

namespace Telerik.Windows.QuickStart
{
	public static class ApplicationCache
	{
		private static IDictionary<string, string> AppCache { get; set; }

		static ApplicationCache()
		{
			AppCache = new Dictionary<string, string>();
		}

		public static bool TryLoadingType(string type, out Example result)
		{
			result = null;

			Type searchType = Type.GetType(ApplicationHelper.ApplicationType.AssemblyQualifiedName.Replace(ApplicationHelper.ApplicationType.FullName, type));

			if (searchType == null)
			{
				foreach (KeyValuePair<string, string> keyValuePair in AppCache)
				{
					searchType = Type.GetType(string.Format("{0},{1}", type, keyValuePair.Key));
					if (null != searchType) break;
				}
			}
			if (searchType != null)
			{
				result = Activator.CreateInstance(searchType) as Example;
				return true;
			}
			return false;
		}

		public static void SaveAssemblyInCache(Assembly assembly)
		{
			if (!AppCache.Keys.Contains(assembly.FullName))
			{
				AppCache.Add(assembly.FullName, assembly.FullName.Split(',')[0]);
			}
		}

		public static bool IsLoadedAssembly(string value)
		{
#if WPF
			return true;
#else
			bool exist =
				AppCache.Any(keyPair => string.Equals(keyPair.Value, value, StringComparison.OrdinalIgnoreCase));

			return exist;
#endif
		}
	}
}
