﻿using System;
using System.Windows.Browser;
using System.Text;

namespace Telerik.Windows.QuickStart
{
	public class BrowserHistoryManager
	{
		[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1810:InitializeReferenceTypeStaticFieldsInline")]
		static BrowserHistoryManager()
		{
			var instance = new BrowserHistoryManager();

			HtmlPage.RegisterScriptableObject(instance.GetType().Name, instance);
		}

		public static event EventHandler<BrowserHistoryEventArgs> BrowserHistoryNavigate;

		internal static void AddBrowserHistory(string currentPage, string pageTitle)
		{
			// TODO: Remove this when bug 31029 is fixed.
			if (HtmlPage.Document.GetProperty("addHistoryPoint") != null)
			{
			    // BUG: Bug 31029 sometimes breaks this call.
				HtmlPage.Document.Invoke("addHistoryPoint", currentPage, pageTitle);
			}
			else
			{
				System.Windows.Deployment.Current.Dispatcher.BeginInvoke(() =>
					AddBrowserHistory(currentPage, pageTitle));
			}
		}

		[ScriptableMember]
		public void HandleNavigate(string state)
		{
			EventHandler<BrowserHistoryEventArgs> handler = null;

			lock (this) { handler = BrowserHistoryNavigate; }

			if (handler != null)
			{
				handler(this, new BrowserHistoryEventArgs(state));
			}
		}
	}
}
