﻿using System;
using System.Globalization;
using System.IO;
using System.Windows.Resources;

namespace Telerik.Windows.QuickStart
{
	public class XbapCodeViewerService : WpfCodeViewerService
	{
		public override void GetSourceFilesListAsync(string examplePath, System.Action<string> callback)
		{
			examplePath = RemoveFolderSeparator(examplePath);

			string formatedValue = string.Format("{0}/Description.txt|{0}/Example.xaml|{0}/Example.xaml.cs", examplePath);
			callback(formatedValue);
		}

		protected override Stream GetResourceStream(string path)
		{
			StreamResourceInfo sri = null;
#if WPF
			string workingDirectory = string.Format(CultureInfo.InvariantCulture, 
				"pack://siteoforigin:,,,/Examples/{0}", path);

			sri = System.Windows.Application.GetRemoteStream(new Uri(workingDirectory, UriKind.RelativeOrAbsolute));
#endif
			if (sri == null)
			{
				return null;
			}
			return sri.Stream;
		}
	}
}