﻿using System.Collections.Generic;
using Telerik.Windows.Controls;

namespace Telerik.Windows.QuickStart
{
	public class ThemesViewModel : NotifyPropertyChangedBase
	{
		public ThemesViewModel()
		{
			if (StyleManager.ApplicationTheme != null)
			{
				this.selectedThemeIndex = Themes.IndexOf(StyleManager.ApplicationTheme.ToString());
			}
			else
			{
				this.selectedThemeIndex = -1;
			}
		}

		private int selectedThemeIndex;

		public int SelectedThemeIndex
		{
			get
			{
				return this.selectedThemeIndex;
			}
			set
			{
				if (this.selectedThemeIndex != value)
				{
					this.selectedThemeIndex = value;
					StyleManager.ApplicationTheme = ThemeManager.FromName(Themes[value]);
					this.OnPropertyChanged("SelectedThemeIndex");
				}
			}
		}

		public static IList<string> Themes
		{
			get
			{
				return ThemeManager.StandardThemeNames;
			}
		}
	}
}