﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Data;

namespace Telerik.Windows.QuickStart
{
	public class ExamplesCollection : ObservableCollection<IExampleItem>
	{
		public ExamplesCollection() { }

		internal ExamplesCollection(List<IExampleItem> listItems)
			: this()
		{
            listItems.ForEach(exampleItem => this.Add(exampleItem));
		}

		public void AddRange(ExamplesCollection exampleCollection)
		{
			exampleCollection.ForEach(item => this.Add(item));
		}

		internal void ApplyFilter(string value)
		{
			this.ForEach(item => ((ExampleItem)item).ApplyFilter(value));
		}

		internal void ExpandedAll(bool value)
		{
			this.ForEach(item => item.IsExpanded = value);
		}
	}

	public class BooleanToVisibilityConverter : IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			return (bool)value ? Visibility.Visible : Visibility.Collapsed;
		}

		public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}
