﻿using System;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using System.Globalization;

namespace Telerik.Windows.QuickStart
{
	public class ExampleStyleSelector : StyleSelector
	{
		public Style ExampleStyle
		{
			get;
			set;
		}

		public Style InnerCategoryStyle
		{
			get;
			set;
		}

		public Style CategoryStyle
		{
			get;
			set;
		}

        public override Style SelectStyle(object item, DependencyObject container)
		{
			ExampleItem exampleItem = item as ExampleItem;
			if (exampleItem != null)
			{
				if (exampleItem.IsExample)
				{
					return this.ExampleStyle;
				}
				else
				{
                    if (exampleItem.Parent == null)
                    {
                        return this.CategoryStyle;
                    }
                    else
                    {
                        return this.InnerCategoryStyle;
                    }
				}
			}
			throw new NotSupportedException(string.Format(CultureInfo.InvariantCulture, "The type {0} is not supported as data item in ExamplesTree.", item.GetType()));
		}
	}
}
