﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;

namespace Telerik.Windows.QuickStart
{
	public class ExampleTemplateSelector : DataTemplateSelector
	{
		public DataTemplate ExampleTemplate
		{
			get;
			set;
		}

		public DataTemplate CategoryTemplate
		{
			get;
			set;
		}

		public override DataTemplate SelectTemplate(object item, DependencyObject container)
		{
			ExampleItem exampleItem = item as ExampleItem;
			if (exampleItem != null)
			{
				if (exampleItem.IsExample)
				{
					return this.ExampleTemplate;
				}
				else
				{
					return this.CategoryTemplate;
				}
			}
			throw new NotSupportedException(string.Format(CultureInfo.InvariantCulture, "The type {0} is not supported as data item in ExamplesTree.", item.GetType()));
		}
	}
}
