﻿using System.Windows.Controls;
using System.Windows;
using Telerik.Windows.Controls;

namespace Telerik.Windows.QuickStart
{
#if WPF
	public partial class MainPage : Page
	{
		public void ApplyMainPageTemplate() { }

		[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1055:UriReturnValuesShouldNotBeStrings")]
		public static string GetNavigateUrl(DependencyObject obj)
		{
			return (string)obj.GetValue(NavigateUrlProperty);
		}

		public static void SetNavigateUrl(DependencyObject obj, string value)
		{
			obj.SetValue(NavigateUrlProperty, value);
		}

		public static readonly DependencyProperty NavigateUrlProperty =
			DependencyProperty.RegisterAttached("NavigateUrl", typeof(string), typeof(MainPage),
			new PropertyMetadata((DependencyObject d, DependencyPropertyChangedEventArgs args) =>
			{
				Button button = d as Button;
				if (button != null)
				{
					button.Click += new RoutedEventHandler(delegate
					{
						MainPage page = button.ParentOfType<MainPage>();
						if (page != null)
						{
							page.ViewModel.FindExampleBypath((string)args.NewValue);
							if (page.ViewModel.SelectedExample != null)
							{
								page.Navigate(page.ViewModel.SelectedExample);
							}
						}
					});
				}
			}));
	}
#endif
}
