﻿using System.Windows;
using System.Windows.Documents;
using System.Windows.Media;

namespace Telerik.Windows.QuickStart.Parser
{
	internal class Token
	{
		public Token(string value, Brush color)
			: this(value, color, false, false)
		{
		}

		public Token(string value, Brush color, bool isBold, bool isItalic)
		{
			this.Value = value;
			this.Color = color;
			this.IsBold = isBold;
			this.IsItalic = isItalic;
		}

		public enum TokenType
		{
			/// <summary>
			/// 
			/// </summary>
			KeyWord,

			/// <summary>
			/// 
			/// </summary>
			Comment,

			/// <summary>
			/// 
			/// </summary>
			String,

			/// <summary>
			/// 
			/// </summary>
			Identifier,

			/// <summary>
			/// 
			/// </summary>
			Other, 

			/// <summary>
			/// 
			/// </summary>
			None
		}

		public string Value
		{
			get;
			private set;
		}

		public Brush Color
		{
			get;
			private set;
		}

		public bool IsBold { get; private set; }
		public bool IsItalic { get; private set; }

		public Run GetRun()
		{
			return new Run()
			{
				Text = this.Value,
				Foreground = this.Color,
				FontWeight = this.IsBold ? FontWeights.ExtraBlack : FontWeights.Normal,
				FontStyle = this.IsItalic ? FontStyles.Italic : FontStyles.Normal
			};
		}
	}
}
